#I have to put a legend

#from http://gastonsanchez.wordpress.com/2012/08/27/scatterplot-matrices-with-ggplot/
makePairs <- function(data) 
{
  grid <- expand.grid(x = 1:ncol(data), y = 1:ncol(data))
  gridUpper <- subset(grid, x < y)
  upper <- do.call("rbind", lapply(1:nrow(gridUpper), function(i) {
    xcol <- gridUpper[i, "x"]
    ycol <- gridUpper[i, "y"]
    data.frame(xvar = names(data)[ycol], yvar = names(data)[xcol], 
               x = data[, xcol], y = data[, ycol], data)
  }))
  upper$xvar <- factor(upper$xvar, levels = names(data))
  upper$yvar <- factor(upper$yvar, levels = names(data))
  
  gridLower<- subset(grid,x>y)
  lower <- do.call("rbind", lapply(1:nrow(gridLower), function(i) {
    xcol <- gridLower[i, "x"]
    ycol <- gridLower[i, "y"]
    data.frame(xvar = names(data)[ycol], yvar = names(data)[xcol],x=(max(data[, xcol])+min(data[, xcol]))/2,y=(max(data[,ycol])+min(data[,ycol]))/2,labs=round(cor(data[, xcol],data[, ycol]),3))
  }))
  
  
  densities <- do.call("rbind", lapply(1:ncol(data), function(i) {
    data.frame(xvar = names(data)[i], yvar = names(data)[i], x = data[, i])
  }))
  list(upper=upper,lower=lower, densities=densities)
}

#this function takes as input a matrix or data.frame and makes the pairs ggplot
funcPlotPairs=function(data){
  
  gridData=makePairs(data)
  
  upperGrid = data.frame(gridData$upper)
#   pPairs=ggplot(upperGrid,aes_string(x = "x", y = "y")) + 
#     facet_grid(xvar ~ yvar, scales = "free") + 
#     geom_point(color="#6495ED") + 
#     stat_density(aes(x = x, y = ..scaled.. * diff(range(x)) + min(x)), 
#                  data = gridData$densities, position = "identity", 
#                  colour = "grey20", geom = "line",lwd=1)+geom_abline(intercept = 0,colour="brown2",lwd=1)+
#     geom_smooth(method = "lm", colour = "black", fill = "blue",lwd=1)+theme_bw() +
#     theme(axis.title.x=element_blank(),axis.title.y=element_blank())+
#     geom_text(data=gridData$lower,aes(x=x,y=y,label=labs,group=NULL),fontface=2,colour="steelblue4")
#   

  pPairs=ggplot(upperGrid,aes_string(x = "x", y = "y")) + 
  facet_grid(xvar ~ yvar, scales = "free") + 
  geom_point(color="#6495ED") + 
  stat_density(aes(x = x, y = ..scaled.. * diff(range(x)) + min(x)), 
               data = gridData$densities, position = "identity", 
               colour = "grey20", geom = "line",lwd=1)+geom_abline(aes(color="Diagonal",fill="Diagonal",intercept = 0, slope=1),lwd=1)+
  geom_smooth(aes(x=x,y=y, color = "Linear_regression",fill = "Linear_regression"),method = "lm",lwd=1)+theme_bw() +
  theme(axis.title.x=element_blank(),axis.title.y=element_blank())+
  geom_text(data=gridData$lower,aes(x=x,y=y,label=labs,group=NULL),fontface=2,colour="steelblue4")+
  scale_fill_manual(name = "Lines", values = c('Diagonal'='white','Linear_regression'='white'))+
  scale_colour_manual(name="Lines", values=c('Diagonal'='brown2','Linear_regression'='black'), guide='legend')+ 
  guides(colour = guide_legend(override.aes = list(linetype=c(1,1))))

  pPairs
}

#this function takes as input a matrix or data.frame and makes the pairs ggplot on methylation data with scale fill gradient

funcPlotPairsMethyl <- function(data){
  
  data <- na.omit(data)
  gridData=makePairs(data)
  
  upperGrid = data.frame(gridData$upper)
  
  pPairs <- ggplot(upperGrid,aes_string(x = "x", y = "y")) + 
    facet_grid(xvar ~ yvar, scales = "free") + geom_hex(aes(x, y), bins = 30) +
    scale_fill_gradientn("", colours =colorRampPalette(c("white", "deepskyblue", "deepskyblue4", "blue"))(10)) + 
    stat_density(aes(x = x, y = ..scaled.. * diff(range(x)) + min(x)), 
                 data = gridData$densities, position = "identity", 
                 colour = "grey20", geom = "line",lwd=1) +
    geom_smooth(aes(x=x,y=y),method = "lm",lwd=1)+theme_bw() +
    theme(axis.title.x=element_blank(),axis.title.y=element_blank()) +
    geom_text(data=gridData$lower,aes(x=x,y=y,label=labs,group=NULL),fontface=2,colour="steelblue4") +
    geom_text(data=gridData$lower,aes(x=50,y=25,label=paste("N=", as.character(nrow(upperGrid))),group=NULL),fontface=2,colour="steelblue4")
  
  pPairs
}

